# -*- coding: utf-8 -*-

import sys
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.uic import *
from types import *

app = QApplication(sys.argv)
w = loadUi("pinch.ui")
img = QImage("test.png")
painter = QPainter()
transformHistory = QTransform()
transformTotal = QTransform()
startPoint = QPoint()

def handleEvents(self, event):
    global transformHistory, transformTotal, startPoint
    if event.type() == QEvent.Gesture:
        g = event.gesture(Qt.PinchGesture)
        if g != None:
            upperLeft = self.mapToGlobal(QPoint())
            scale = g.totalScaleFactor()
            angle = g.totalRotationAngle()
            centerPoint = g.centerPoint() - upperLeft
            if g.state() == Qt.GestureStarted:
                startPoint = g.centerPoint() - upperLeft
            transformTotal = transformHistory * QTransform().translate(centerPoint.x(), centerPoint.y()).rotate(angle).scale(scale, scale).translate(-startPoint.x(), -startPoint.y())
            if g.state() == Qt.GestureFinished:
                transformHistory = transformTotal
            self.update()
        else:
            g = event.gesture(Qt.TapGesture)
            if g.state() == Qt.GestureFinished:
                print "tap ", g.position()
                transformTotal = QTransform()
                transformHistory = QTransform()
                self.update()
    elif event.type() == QEvent.Paint:
        painter.begin(self)
        painter.setTransform(transformTotal)
        painter.drawImage(0, 0, img)
        painter.end()
    return True

w.widget.event = MethodType(handleEvents, w.widget)
w.widget.grabGesture(Qt.PinchGesture)
w.widget.grabGesture(Qt.TapGesture)
w.show()
sys.exit(app.exec_())